#! /usr/bin/python3

# rospy for the subscriber
import rospy
from base_station.srv import Overwatch
import sys

def main(action, name):

    # read in parameters from command line
    # namespc = str(rospy.get_param("~name"))
    # act = int(action)
    namespc = str(name)
    action = int(action)

    rospy.init_node("overwatchControl_" + namespc + "_" + str(action), anonymous = True)

    srvName = namespc + "/overwatch"

    rospy.loginfo("calling overwatch control service...")
    rospy.loginfo("namespace: " + namespc)
    rospy.loginfo("action: " + str(action))
    # print("namespace: " + namespc)
    # print("action: " + str(action))

    # request drone to open stereo images
    rospy.wait_for_service(srvName)
    service_proxy = rospy.ServiceProxy(srvName, Overwatch)
    response = service_proxy(start = True, action = action) # go baby go
    rospy.loginfo(response)

if __name__ == "__main__":
    main(sys.argv[1], sys.argv[2])
