#! /home/llh/anaconda3/bin/python
import rospy
import sys
# from osc4py3.as_eventloop import *
# from osc4py3.as_allthreads import *
from osc4py3.as_comthreads import *
from osc4py3 import oscmethod as osm
from geometry_msgs.msg import Point
from std_msgs.msg import Float32
import netifaces as ni

# blah blah blah
# AHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH

class OSCTranslator():
    def __init__(self):
        self.positionPub = rospy.Publisher('target_position', Point, queue_size = 1)
        self.headingPub = rospy.Publisher('target_heading', Float32, queue_size = 1)
        rospy.init_node('puredata_publisher')
        self.rate = rospy.Rate(20)
        self.targetPosition = Point()
        self.targetHeading = 0.0
        rospy.loginfo("starting osc server")

        # Make server channels to receive packets.
        # get wifi interfaces ip
        ip = ni.ifaddresses('wlp0s20f3')[ni.AF_INET][0]['addr']
        rospy.loginfo("starting osc server on " + str(ip))
        # osc_udp_server(ip, 3721, "aservername")
        osc_udp_server('127.0.0.1', 3721, "aservername")
        osc_method("/position", self.handlerfunctionflex, argscheme=osm.OSCARG_ADDRESS + osm.OSCARG_DATAUNPACK)
        # osc_method("/sound/one", self.handlerfunctionflex, argscheme=osm.OSCARG_ADDRESS + osm.OSCARG_DATAUNPACK)
        # osc_method("/master", self.handlerfunctionflex, argscheme=osm.OSCARG_ADDRESS + osm.OSCARG_DATAUNPACK)

    def handlerfunctionflex(self, address, *args):
        # Will receive message data unpacked in s, x, y
        rospy.loginfo("from: " + address + ": " + str(args))
        if (address == "/position"):
            rospy.loginfo("publishing position...")
            self.targetPosition.x = args[0]
            self.targetPosition.y = args[1]
            self.targetPosition.z = args[2]
            self.positionPub.publish(self.targetPosition)
            self.targetHeading = args[3]
            self.headingPub.publish(self.targetHeading)
        elif (address == "/sound/one"):
            rospy.loginfo("publishing sound...")
        elif (address == "/master"):
            rospy.loginfo("publishing master vol...")
            # pure data will handle sounds..?
        pass

if __name__ == "__main__":
    osc_startup()
    oscer = OSCTranslator()
    rospy.loginfo("starting osc process loop")
    while not rospy.is_shutdown():
        # rospy.loginfo("processing osc msgs...")
        osc_process()
        oscer.rate.sleep()
        # rospy.spin()
    osc_terminate()
