#!/usr/bin/python3
import requests
import rospy
from sensor_msgs.msg import NavSatFix
import json
import datetime

# # create a new device, deviceis is the primary key
# r = requests.post('http://127.0.0.1:8000/app3/gpsdatas/',auth=('username','password'), data = {'deviceid':'max_testing', 'taskid':'sar_put2','gpsdata':'{'gps':['stamp':004,'lat':-81,'log':37]}'})
#
# # update record based on primary key. For example: './max_testing/' is added as pk
# r = requests.patch('http://127.0.0.1:8000/app3/gpsdatas/max_testing/', auth=('username','password'), data = {'deviceid':'max_testing', 'taskid':'sar_put2','gpsdata':'{'gps':['stamp':004,'lat':-80,'log':38]}'})

def callback(data, args):
  deviceId = args[0]
  taskId = args[1]
  authorization = args[2]
  baseTable = args[3]
  gpsTable = args[4]
  #rospy.loginfo(rospy.get_caller_id() + '%s', data)
  #rospy.loginfo('connection status: ' + str(mydb.is_connected()))
  if data.header.seq % 10 == 0: # only update every 10th message to avoid over crowding the sql
    gps_data = {
      'gps' : [
        {
          'stamp' : data.header.seq,
          'timestamp' : data.header.stamp.secs,
          'lat' : data.latitude,
          'long' : data.longitude
        },
      ]
    }

    gpsData = {'deviceid':deviceId, 'taskid':taskId, 'gpsdata' : json.dumps(gps_data)}
    try:
        r = requests.patch(baseTable + gpsTable + deviceId + '/',auth=authorization, data = gpsData)
    except:
        pass
        print("aw fuck it")

def main():

    baseTable = 'http://127.0.0.1:8000'
    gpsTable = '/gpsdatas/'
    waypointTable = '/waypointsdata/'
    authorization = ('larkinheintzman','password')
    deviceId = 'drone_' + str(rospy.get_param('drone_id'))
    taskId = 'task_0'
    topic = 'dji_sdk/gps_position'

    rospy.init_node('sql_uploader')
    rospy.Subscriber(topic, NavSatFix, callback, (deviceId, taskId, authorization, baseTable, gpsTable))
    updateRate = rospy.Rate(20)

    while not rospy.has_param('/robot_list/robot_' + str(rospy.get_param('drone_id')) + '/waypoints'):
        rospy.loginfo("waiting for parameter...")
        updateRate.sleep()

    # upload waypoints to GUI
    waypoint_dict = rospy.get_param('/robot_list/robot_' + str(rospy.get_param('drone_id')) + '/waypoints')

    # rospy.loginfo("waypoint dict:")
    # rospy.loginfo(waypoint_dict)

    waypoint_json = []
    for i,pt in enumerate(waypoint_dict.keys()):
        waypoint_json.append({'stamp' : waypoint_dict[pt][0], 'timestamp' : -1, 'lat' : waypoint_dict[pt][1], 'long' : waypoint_dict[pt][2]}) # leaving out altitude for now!

    waypoint_json = sorted(waypoint_json, key = lambda i: i['stamp'])

    waypointData = {'deviceid':deviceId, 'taskid':taskId, 'waypointsdata' : json.dumps(waypoint_json)}
    try:
        # post new vehicle
        r = requests.post(baseTable + waypointTable, auth=authorization, data = waypointData)
        # patch old vehicle's waypoints
        r = requests.patch(baseTable + waypointTable + deviceId + '/', auth=authorization, data = waypointData)
    except:
        rospy.loginfo("could not post waypoints")

    # also create (post) new device on table
    gps_data = {
      'gps' : [
        {
          'stamp' : 0,
          'timestamp' : 0,
          'lat' : 37.0,
          'long' : -80
        },
      ]
    }
    gpsData = {'deviceid':deviceId, 'taskid':taskId, 'gpsdata' : json.dumps(gps_data)}
    try:
        r = requests.post(baseTable + gpsTable,auth=authorization, data = gpsData)
    except:
        rospy.loginfo("could not post new gps")

    rospy.loginfo('waypoints updated')

    rospy.spin()

if __name__ == '__main__':
    main()
