#!/usr/bin/python3
from tools import meters2lat_lon, lat_lon2meters, normalizeAngle, point_rotation
import numpy as np
import rospy

def generateWaypoints():
    rospy.init_node("waypointGenerator")
    anchorPoint = rospy.get_param("~anchorPoint")
    pathPoints = rospy.get_param("~pathPoints")
    baseWaypointAltitude = rospy.get_param("~altitude")
    droneNum = rospy.get_param("~droneNum")
    angleOffset = rospy.get_param("~angleOffset")

    # waypointAltitudeIncrement = baseWaypointAltitude # increase altitude for each drone in team
    waypointAltitudeIncrement = 10 # increase altitude for each drone in team

    # decide if path is "preplanned" or not
    if (len(pathPoints) != 0):
        apMeters = lat_lon2meters(anchorPoint)
        tempDict = {"waypoints" : {}, "positions" : {}, "numWaypoints" : 0, "numPositions" : 0}
        waypointDict = {}
        # define dictionary
        numWaypoints = len(pathPoints)
        numPositions = len(pathPoints)

        for d in range(droneNum):
            # rospy.loginfo("blah!")
            # print(d)
            waypointDict["robot_{}".format(d)] = {}
            waypointDict["robot_{}".format(d)] = {}
            waypointDict["robot_{}".format(d)]["waypoints"] = {}
            waypointDict["robot_{}".format(d)]["positions"] = {}
            for i, pt in enumerate(pathPoints):
            # for i, offset in enumerate(waypointOffsets):
                # waypointLatLon = pt
                # calculate angle offset
                ptMeters = lat_lon2meters(pt)
                rotatedOffset = point_rotation([0,0], [ptMeters[0] - apMeters[0], ptMeters[1] - apMeters[1]], angleOffset*d)
                waypointLatLon = meters2lat_lon([rotatedOffset[0] + apMeters[0], rotatedOffset[1] + apMeters[1]])
                waypointHeading = 0.0
                latLonPt = lat_lon2meters(pt)
                positionXY = [latLonPt[0] - apMeters[0], latLonPt[1] - apMeters[1]]

                # waypoints
                waypointDict["robot_{}".format(d)]["waypoints"].update({"waypoint_{}".format(i) : [i, waypointLatLon[0], waypointLatLon[1], baseWaypointAltitude + d*waypointAltitudeIncrement, waypointHeading]})
                # positions
                waypointDict["robot_{}".format(d)]["positions"].update({"position_{}".format(i) : [i, positionXY[0], positionXY[1], baseWaypointAltitude + d*waypointAltitudeIncrement, waypointHeading]})

            # do this betta
            waypointDict["robot_{}".format(d)]["numWaypoints"] = numWaypoints
            waypointDict["robot_{}".format(d)]["numPositions"] = numPositions
        # print(waypointDict)
        rospy.set_param("/robot_list", waypointDict)
    return
    # print(waypointDict)

if __name__ == "__main__":
    generateWaypoints()
